#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fakemeta>
#include <fakemeta_util>
#include <fun>
#include <hamsandwich>

#if AMXX_VERSION_NUM < 183
	#include <dhudmessage>
#endif

#define PLUGIN "Simple VIP [CSDM]"
#define VERSION "1.1"
#define AUTHOR "ArtHa"

#define VIP ADMIN_LEVEL_H

// HP BONUS
new hp_bonus, g_pHp[ 3 ], chat_message

// Bullet Damage
new show_received, bulletdmg_vip, received_vip, g_visible, bulletdmg_type
new Float: Yv[ 33 ]
new Float: Ya[ 33 ]

// Fall Damage
new fall_damage

// Vip Menu
new bool:g_vipmenu[33], Respawn[33], vipmenu_hp, armor, armor_max, vip_speed, vip_gravity, visibility, g_event_weapon[ 33 ]
new bool:g_power[33][6]

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_dictionary( "simple_vip_csdm.txt" )

	// HP BONUS
	register_event( "DeathMsg", "Event_DeathMsg", "a" )
	hp_bonus = register_cvar( "amx_hpbonus", "1" )
	chat_message = register_cvar( "amx_hpbonus_msg", "2" )
	g_pHp[ 0 ] = register_cvar( "amx_vip_hpadd", "10" )
	g_pHp[ 1 ] = register_cvar( "amx_vip_hsadd", "20" )
	g_pHp[ 2 ] = register_cvar( "amx_vip_hpmax", "200" )
	
	// Bullet Damage
	register_event( "Damage", "on_damage", "b", "2!0", "3=0", "4!0" )
	show_received = register_cvar( "show_received", "1" )
	bulletdmg_vip = register_cvar( "bulletdmg_vip", "1" )
	received_vip = register_cvar( "receivedmg_vip", "1" )
	g_visible = register_cvar( "visible_player", "1" )
	bulletdmg_type = register_cvar( "bullet_damage_type", "2" )
	
	// Fall Damage
	RegisterHam( Ham_TakeDamage, "player", "OnCBasePlayer_TakeDamage" )
	fall_damage = register_cvar( "amx_no_falldmg", "1" )
	
	// Vip Menu
	RegisterHam( Ham_Spawn, "player", "player_spawn", 1 )
	register_event( "CurWeapon", "event_CurWeapon", "be", "1=1" );
	register_cvar( "vipmenu_respawn", "5" )
	register_clcmd( "say /vipmenu", "vipmenu" )
	vipmenu_hp = register_cvar( "amx_vipmenu_hpadd", "50" )
	armor = register_cvar( "amx_vipmenu_armor", "80" )
	armor_max = register_cvar( "amx_vip_armormax", "100" )
	vip_speed = register_cvar("amx_vip_speed", "280.0")
	vip_gravity = register_cvar("amx_vip_gravity", "0.7")
	visibility = register_cvar( "amx_vip_visibility", "127" )
}

public plugin_cfg()
{
	new cfgdir[32];
	get_configsdir(cfgdir, charsmax(cfgdir));
	
	server_cmd("exec %s/simple_vip_csdm.cfg", cfgdir);
}

public Event_DeathMsg( )
{
	new iKiller = read_data( 1 )
	new iVictim = read_data( 2 )
	new HeadShot = read_data( 3 )
	
	if( get_user_team( iKiller ) == get_user_team( iVictim ) )
		return
	
	if( iKiller && iVictim != iKiller && get_user_flags(iKiller) & VIP && get_pcvar_num(hp_bonus) == 1)
	{
		static maxhp, hp
		maxhp = get_pcvar_num( g_pHp[ 2 ] )
		hp = get_user_health( iKiller )
		
		if( hp != maxhp )
		{
			new BonusHp;
			if( HeadShot ) BonusHp = get_pcvar_num( g_pHp[ 1 ] )
			else BonusHp = get_pcvar_num( g_pHp[ 0 ] )
			
			if( hp + BonusHp > maxhp )
			{
				set_user_health( iKiller, maxhp )
				
				if(get_pcvar_num(chat_message) == 1)
					ChatColor(iKiller, "%L", LANG_PLAYER, "HP_BONUS", maxhp - hp )
					
				else if(get_pcvar_num(chat_message) == 2)
				{
					set_dhudmessage( 0,255,0, -1.0, 0.15, 1, 1.0, 1.0, 0.1, 0.2)
					show_dhudmessage(iKiller, "%L", LANG_PLAYER, "HP_BONUS", maxhp - hp )
				}	
			} 
			else
			{
				set_user_health( iKiller, hp + BonusHp )
				
				if(get_pcvar_num(chat_message) == 1)
					ChatColor(iKiller, "%L", LANG_PLAYER, "HP_BONUS", BonusHp )
					
				else if(get_pcvar_num(chat_message) == 2)
				{
					set_dhudmessage( 0,255,0, -1.0, 0.15, 1, 1.0, 1.0, 0.1, 0.2)
					show_dhudmessage(iKiller, "%L", LANG_PLAYER, "HP_BONUS", BonusHp )
				}
			}
		}
	}	
}

public on_damage(id) 
{ 
	static attacker; attacker = get_user_attacker(id)
	static damage; damage = read_data(2)
	
	if(get_pcvar_num(show_received) == 1)
	{
		if(get_pcvar_num(received_vip) == 1)
		{
			if( get_user_flags(id) & VIP ) 
			{
				if(get_pcvar_num(bulletdmg_type) == 1)
				{
					set_hudmessage(255, 0, 0, 0.45, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
					ShowSyncHudMsg(id, CreateHudSyncObj(), "%L^n", LANG_PLAYER, "MINUS_DAMAGE", damage)
				}
				
				else
				{
					set_dhudmessage( 255,0,0, 0.45, Yv[ id ], 1, 0.1, 4.0, 0.1, 0.1)
					show_dhudmessage(id, "%L^n", LANG_PLAYER, "MINUS_DAMAGE", damage)
					
					Yv[ id ] += 0.05
					set_task( 3.0, "RestartdHudPos1", id )
				}
			}
		}

		else
		{
			if(get_pcvar_num(bulletdmg_type) == 1)
			{
				set_hudmessage(255, 0, 0, 0.45, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
				ShowSyncHudMsg(id, CreateHudSyncObj(), "%L^n", LANG_PLAYER, "MINUS_DAMAGE", damage)
			}

			else
			{
				set_dhudmessage( 255,0,0, 0.45, Yv[ id ], 1, 0.1, 4.0, 0.1, 0.1)
				show_dhudmessage(id, "%L^n", LANG_PLAYER, "MINUS_DAMAGE", damage)
				
				Yv[ id ] += 0.05
				set_task( 3.0, "RestartdHudPos1", id )
			}
		}
	}

	if(is_user_connected(attacker)) 
	{
		if(get_pcvar_num(bulletdmg_vip) == 1)
		{
			if( get_user_flags(attacker) & VIP )
			{
				if(get_pcvar_num(g_visible) == 1)
				{
					if(fm_is_ent_visible(attacker,id))
					{
						if(get_pcvar_num(bulletdmg_type) == 1)
						{
							set_hudmessage(0, 255, 0, 0.55, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
							ShowSyncHudMsg(attacker, CreateHudSyncObj(), "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
						}
						
						else if(get_pcvar_num(bulletdmg_type) == 2)
						{
							set_dhudmessage( 0,255,0, 0.55, Ya[ attacker ], 1, 0.1, 4.0, 0.1, 0.1)
							show_dhudmessage(attacker, "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
							Ya[ attacker ] += 0.05
							set_task( 3.0, "RestartdHudPos2", attacker )
						}
					}
				}
				
				else
				{
					if(get_pcvar_num(bulletdmg_type) == 1)
					{
						set_hudmessage(0, 255, 0, 0.55, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
						ShowSyncHudMsg(attacker, CreateHudSyncObj(), "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
					}

					else if(get_pcvar_num(bulletdmg_type) == 2)
					{
						set_dhudmessage( 0,255,0, 0.55, Ya[ attacker ], 1, 0.1, 4.0, 0.1, 0.1)
						show_dhudmessage(attacker, "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
						Ya[ attacker ] += 0.05
						set_task( 3.0, "RestartdHudPos2", attacker )
					}
				}
			}
		}
		
		else if(get_pcvar_num(bulletdmg_vip) == 2)
		{
			if(get_pcvar_num(g_visible) == 1)
			{
				if(fm_is_ent_visible(attacker,id))
				{
					if(get_pcvar_num(bulletdmg_type) == 1)
					{
						set_hudmessage(0, 255, 0, 0.55, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
						ShowSyncHudMsg(attacker, CreateHudSyncObj(), "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
					}

					else if(get_pcvar_num(bulletdmg_type) == 2)
					{
						set_dhudmessage( 0,255,0, 0.55, Ya[ attacker ], 1, 0.1, 4.0, 0.1, 0.1)
						show_dhudmessage(attacker, "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
						Ya[ attacker ] += 0.05
						set_task( 3.0, "RestartdHudPos2", attacker )
					}
				}
			}

			else
			{
				if(get_pcvar_num(bulletdmg_type) == 1)
				{
					set_hudmessage(0, 255, 0, 0.55, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
					ShowSyncHudMsg(attacker, CreateHudSyncObj(), "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
				}

				else if(get_pcvar_num(bulletdmg_type) == 2)
				{
					set_dhudmessage( 0,255,0, 0.55, Ya[ attacker ], 1, 0.1, 4.0, 0.1, 0.1)
					show_dhudmessage(attacker, "%L^n", LANG_PLAYER, "PLIUS_DAMAGE", damage)
					Ya[ attacker ] += 0.05
					set_task( 3.0, "RestartdHudPos2", attacker )
				}
			}
		}
	}
}

public RestartdHudPos1( id )
{
	Yv[ id ] = 0.50
}

public RestartdHudPos2( id )
{
	Ya[ id ] = 0.55
}

public player_spawn(id)
{
	if( get_user_flags(id) & VIP && is_user_alive(id) )
	{
		Respawn[id]++
		
		if( g_vipmenu[id] && Respawn[id] >= get_cvar_num( "vipmenu_respawn" ) )
		{
			g_vipmenu[id] = false;
		}
		
		setPower(id)
	}
}

public vipmenu(id)
{
	if( is_user_alive(id) )
	{
		if( get_user_flags(id) & VIP )
		{
			if( g_vipmenu[id] )
				ChatColor( id, "%L", LANG_PLAYER, "CANT_USE" )
				
			else
			{
				removePower(id)
				
				new buffer[1024];
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "VIPMENU");		
				new menu = menu_create(buffer, "menu_handler");
				
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "HP_CHOOSE");
				menu_additem(menu, buffer, "1", 0);
				
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "AP_CHOOSE");
				menu_additem(menu, buffer, "2", 0);
				
				menu_addtext(menu, "\r----------------------------", 0);
				
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "SPEED_CHOOSE");
				menu_additem(menu, buffer, "3", 0);
				
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "GRAVITY_CHOOSE");
				menu_additem(menu, buffer, "4", 0);
				
				menu_addtext(menu, "\r----------------------------", 0);
				
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "GRENADES_CHOOSE");
				menu_additem(menu, buffer, "5", 0);
				
				formatex(buffer, charsmax(buffer), "%L", LANG_PLAYER, "INVISIBILITY_CHOOSE");
				menu_additem(menu, buffer, "6", 0);
				
				menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
				menu_display(id, menu, 0);
			}
		}
		
		else
			ChatColor( id, "%L", LANG_PLAYER, "NO_VIP" )
	}
	
	else
		ChatColor( id, "%L", LANG_PLAYER, "DEATH_MSG" )
}

public menu_handler(id, menu, item)
{
	if( item == MENU_EXIT )
	{
		g_vipmenu[id] = false;
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	new data[6], iName[64];
	new acess, callback;
   
	menu_item_getinfo(menu, item, acess, data,6, iName, 63, callback);
	new key = str_to_num(data);
	
	switch(key)
	{
		case 1:
		{
			g_power[id][0] = true
			setHP(id)
		}
		
		case 2:
		{
			g_power[id][1] = true
			setAP(id)
		}
		
		case 3:
		{
			g_power[id][2] = true
			setSpeed(id)
		}
		
		case 4:
		{
			g_power[id][3] = true
			setGravity(id)
		}
		
		case 5:
		{
			g_power[id][4] = true
			grenades(id)
		}
		
		case 6:
		{
			g_power[id][5] = true
			invisibility(id)
		}
	}
	
	g_vipmenu[id] = true;
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public setHP(id)
{
	if(get_user_health(id) < get_pcvar_num( g_pHp[ 2 ] ))
	{
		set_user_health( id, get_user_health( id ) + get_pcvar_num( vipmenu_hp ) )

		if(get_user_health(id) > get_pcvar_num( g_pHp[ 2 ] ))
			set_user_health(id, get_pcvar_num( g_pHp[ 2 ] ))
			
		ChatColor( id, "%L", id, "SET_HP" )	
	}

	else
		ChatColor( id, "%L", id, "FULL_HP" )
}

public setAP(id)
{
	if(get_user_armor(id) < get_pcvar_num( armor_max ))
	{
		set_user_armor( id, get_user_armor( id ) + get_pcvar_num( armor ) )

		if(get_user_armor(id) > get_pcvar_num( armor_max ))
			set_user_armor(id, get_pcvar_num( armor_max ))

		ChatColor( id, "%L", id, "SET_AP" )	
	}
	else
		ChatColor( id, "%L", id, "FULL_AP" )
}

public setSpeed(id)
{
	set_user_maxspeed(id, get_pcvar_float(vip_speed))
	ChatColor( id, "%L", id, "SET_SPEED" )
}

public setGravity(id)
{
	set_user_gravity(id, get_pcvar_float(vip_gravity))
	ChatColor( id, "%L", id, "SET_GRAVITY" )
}

public grenades(id)
{
	give_item(id, "weapon_hegrenade");
	give_item(id, "weapon_smokegrenade");
	give_item(id, "weapon_flashbang");
	cs_set_user_bpammo(id, CSW_FLASHBANG, 2);
	ChatColor( id, "%L", id, "GRENADES" )
}

public invisibility(id)
{
	set_user_rendering(id, kRenderFxNone, 0, 0, 0, kRenderTransTexture, get_pcvar_num( visibility ))
	ChatColor( id, "%L", id, "INVISIBILITY" )
}

public setPower(id)
{
	if(is_user_alive(id))
	{
		if(g_power[id][0])
			setHP(id)
			
		else if(g_power[id][1])
			setAP(id)
			
		else if(g_power[id][2])
			setSpeed(id)
			
		else if(g_power[id][3])
			setGravity(id)
			
		else if(g_power[id][4])
			grenades(id)
			
		else if(g_power[id][5])
			invisibility(id)	
	}
}

public removePower(id)
{
	Respawn[ id ] = 0
	
	if(g_power[id][0])
		g_power[id][0] = false
		
	else if(g_power[id][1])
		g_power[id][1]= false
		
	else if(g_power[id][2])
	{
		g_power[id][2] = false
		removeSpeed(id)
	}
	
	else if(g_power[id][3])
	{
		g_power[id][3] = false
		removeGravity(id)
	}
		
	else if(g_power[id][4])
		g_power[id][4] = false

	else if(g_power[id][5])
		g_power[id][5] = false
}

public event_CurWeapon( id )
{
	new weapon;
	weapon = read_data( 2 );

	if(g_power[id][2])
	{
		if ( weapon != g_event_weapon[ id ] )
		{
			set_user_maxspeed(id, get_pcvar_float(vip_speed))
		}
	}
}

public removeSpeed(id)
{
	set_user_maxspeed(id, 250.0)
}

public removeGravity(id)
{
	set_user_gravity(id, 1.0)
}

public client_putinserver( id )
{
	Ya[ id ] = 0.45
	Yv[ id ] = 0.50

	g_vipmenu[ id ] = false
	removePower(id)
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32]
    static msg[192]
    vformat(msg, 191, input, 3)
   
    replace_all(msg, 191, "!g", "^4") // Green Color
    replace_all(msg, 191, "!y", "^1") // Default Color
    replace_all(msg, 191, "!t", "^3") // Team Color
   
    if (id) players[0] = id; else get_players(players, count, "ch")
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
}

public OnCBasePlayer_TakeDamage( id, iInflictor, iAttacker, Float:flDamage, bitsDamageType )
{
    if( bitsDamageType & DMG_FALL )
    {
		if(get_pcvar_num(fall_damage) == 1)
		{
			if( get_user_flags(id) & VIP )
			{
				return HAM_SUPERCEDE
			}
		}
		
		else if(get_pcvar_num(fall_damage) == 2)
		{
			return HAM_SUPERCEDE
		}
    }
    return HAM_IGNORED
}